#include <primitives/primitives.h>
#include <string>
#include <fstream>
#include <map>
#include <stack>


using namespace raytracer;
using namespace raytracer::primitives;
using namespace math;

Primitive raytracer::primitives::mesh(const std::string& fileName)
{
	std::ifstream inFile;
	inFile.open(fileName);
	int n_vertices;
	std::map<int, Point3D> vertices;
	inFile >> n_vertices;
	double x, y, z;
	
	for (int i = 0; i != n_vertices; i++)
	{
		inFile >> x >> y >> z;
		vertices[i] = Point3D(x, y, z);
	}
	assert(vertices.size() == n_vertices);
	std::stack<Primitive> stack;
	std::string primitiveType;
	int p1, p2, p3;
	while (true)
	{
		inFile >> primitiveType;
		if (primitiveType == "T") {
			inFile >> p1 >> p2 >> p3;
			stack.push(triangle(vertices.at(p1), vertices.at(p2), vertices.at(p3)));
		}
		else if (primitiveType == "B") {
			inFile >> p1;
			std::vector<Primitive> primitives;
			for (int i = 0; i < p1; i++) {
				primitives.push_back(stack.top());
				stack.pop();
			}
			stack.push(bounding_box_accelerator(make_union(primitives)));
		}
		else
		{
			assert(primitiveType == "END");
			return stack.top();
		}
	}
}
