#include "raytracers/ray-tracer-v4.h"
#include "easylogging++.h"
#include <stdlib.h> 

using namespace imaging;
using namespace math;
using namespace raytracer;

Color raytracer::raytracers::_private_::RayTracerV4::process_light_ray(const Scene& scene, const MaterialProperties& matprop, const Hit& hit, const math::Ray& ray, const LightRay& lightray) const
{
	auto result = colors::black();

	Hit rayhit;

	if (scene.root->find_first_positive_hit(lightray.ray, &rayhit))
	{
		double t = rayhit.t;

		if (0 <= t && t < 1 - pow(10, -10))
		{
			return result;
		}
	}


	result += RayTracerV3::process_light_ray(scene, matprop, hit, ray, lightray);
	return result;
}

RayTracer raytracer::raytracers::v4()
{
	return raytracer::RayTracer(std::make_shared<_private_::RayTracerV4>());
}


